diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionElementSource.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionElementSource.java
new file mode 100644
index 0000000000..999b7c56ec
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/DescriptionElementSource.java
@@ -0,0 +1,216 @@
+// $Id$
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.model.description;
+
+import javax.persistence.Column;
+import javax.persistence.Entity;
+import javax.persistence.FetchType;
+import javax.persistence.JoinColumn;
+import javax.persistence.ManyToOne;
+import javax.xml.bind.annotation.XmlElement;
+import javax.xml.bind.annotation.XmlIDREF;
+import javax.xml.bind.annotation.XmlSchemaType;
+import javax.xml.bind.annotation.XmlType;
+
+import org.apache.log4j.Logger;
+import org.hibernate.annotations.Any;
+import org.hibernate.annotations.Cascade;
+import org.hibernate.annotations.CascadeType;
+import org.hibernate.envers.Audited;
+import org.hibernate.envers.NotAudited;
+
+import eu.etaxonomy.cdm.model.common.OriginalSourceBase;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
+import eu.etaxonomy.cdm.model.name.TaxonNameBase;
+import eu.etaxonomy.cdm.model.reference.Reference;
+
+/**
+ * This class represents an {@link eu.etaxonomy.cdm.model.common.IOriginalSource IOriginalSource}
+ * that can be used with {@link eu.etaxonomy.cdm.model.description.DescriptionElementBase description elements}.
+ * Additionally to the core functionally of IOriginalSource a {@link eu.etaxonomy.cdm.model.name.TaxonNameBase taxon name}
+ * can be stored that points to the name used in the source. This is needed because description always belong
+ * to accepted taxa while the referenced citations may use synonym names.
+ * </BR>
+ * The use of "originalNameString" within a DescriptionElementSource has to be discussed.
+ * In general this string is to be used for different representations of the sourced object. In this classes
+ * context it could also stand for the string representation of the taxon name used in the source. This
+ * may make sense if the taxon name is not available in the CDM and the user for some reason does not want 
+ * to create a new ful {@link eu.etaxonomy.cdm.model.name.TaxonNameBase taxon name}.
+ *  
+ * @author a.mueller
+ * @created 18.09.2009
+ */
+@XmlType(name = "DescriptionElementSource", propOrder = {
+	    "sourcedObj",
+	    "nameUsedInSource"
+	})
+@Entity
+@Audited
+public class DescriptionElementSource extends OriginalSourceBase<DescriptionElementBase>{
+	private static final long serialVersionUID = -8487673428764273806L;
+	@SuppressWarnings("unused")
+	private static final Logger logger = Logger.getLogger(DescriptionElementSource.class);
+	
+	/**
+	 * Factory method
+	 * @return
+	 */
+	public static DescriptionElementSource NewInstance(OriginalSourceType type){
+		return new DescriptionElementSource(type);
+	}
+	
+	public static DescriptionElementSource NewDataImportInstance(String id){
+		DescriptionElementSource result = new DescriptionElementSource(OriginalSourceType.Import);
+		result.setIdInSource(id);
+		return result;
+	}
+
+	public static DescriptionElementSource NewDataImportInstance(String id, String idNamespace){
+		DescriptionElementSource result = NewDataImportInstance(id);
+		result.setIdNamespace(idNamespace);
+		return result;
+	}
+	
+	public static DescriptionElementSource NewDataImportInstance(String id, String idNamespace, Reference ref){
+		DescriptionElementSource result = NewDataImportInstance(id, idNamespace);
+		result.setCitation(ref);
+		return result;
+	}
+	
+	public static DescriptionElementSource NewInstance(OriginalSourceType type, String id, String idNamespace, Reference citation){
+		DescriptionElementSource result = NewInstance(type);
+		result.setIdInSource(id);
+		result.setIdNamespace(idNamespace);
+		result.setCitation(citation);		
+		return result;
+	}
+
+	public static DescriptionElementSource NewInstance(OriginalSourceType type, String id, String idNamespace, Reference citation, String microCitation){
+		DescriptionElementSource result = NewInstance(type, id, idNamespace, citation);
+		result.setCitationMicroReference(microCitation);
+		return result;
+	}
+	
+	public static DescriptionElementSource NewInstance(OriginalSourceType type, String id, String idNamespace, Reference citation, String microReference, TaxonNameBase nameUsedInSource, String originalNameString){
+		DescriptionElementSource result = NewInstance(type, id, idNamespace, citation, microReference);
+		result.setNameUsedInSource(nameUsedInSource);
+		result.setOriginalNameString(originalNameString);
+		return result;
+	}
+	
+	public static DescriptionElementSource NewPrimarySourceInstance(Reference citation, String microCitation){
+		DescriptionElementSource result = NewInstance(OriginalSourceType.PrimaryTaxonomicSource);
+		result.setCitation(citation);
+		result.setCitationMicroReference(microCitation);
+		return result;
+	}
+
+	public static DescriptionElementSource NewPrimarySourceInstance(Reference citation, String microReference, TaxonNameBase nameUsedInSource, String originalNameString){
+		DescriptionElementSource result = NewPrimarySourceInstance(citation, microReference);
+		result.setNameUsedInSource(nameUsedInSource);
+		result.setOriginalNameString(originalNameString);
+		return result;
+	}
+
+	
+	
+	@XmlElement(name = "SourcedObject")
+    @XmlIDREF
+    @XmlSchemaType(name = "IDREF")
+	@Any(metaDef = "CdmBase",
+	    	 metaColumn=@Column(name = "sourcedObj_type"),
+	    	 fetch = FetchType.LAZY,
+	    	 optional = false)
+	@JoinColumn(name = "sourcedObj_id")
+	@NotAudited
+	private DescriptionElementBase sourcedObj;
+	
+	@XmlElement(name = "nameUsedInSource")
+	@XmlIDREF
+	@XmlSchemaType(name = "IDREF")
+	@ManyToOne(fetch = FetchType.LAZY)
+	@Cascade({CascadeType.SAVE_UPDATE})
+	private TaxonNameBase<?,?> nameUsedInSource;
+	
+//*********************** CONSTRUCTOR ******************************/	
+	
+	//for hibernate use only
+	private DescriptionElementSource(){
+		super();
+	}
+	
+	private DescriptionElementSource(OriginalSourceType type){
+		super(type);
+	}
+	
+	
+// **************************  GETTER / SETTER ***************************/
+	
+	
+	/* (non-Javadoc)
+	 * @see eu.etaxonomy.cdm.model.common.IOriginalSource#getSourcedObj()
+	 */
+	public DescriptionElementBase getSourcedObj() {
+		return sourcedObj;
+	}
+	
+	/* (non-Javadoc)
+	 * @see eu.etaxonomy.cdm.model.common.IOriginalSource#setSourcedObj(eu.etaxonomy.cdm.model.common.ISourceable)
+	 */
+	public void setSourcedObj(DescriptionElementBase sourcedObj) {
+		this.sourcedObj = sourcedObj;
+	}
+	
+	
+	/**
+	 * @return the taxonNameUsedInSource
+	 */
+	public TaxonNameBase getNameUsedInSource() {
+		return nameUsedInSource;
+	}
+
+	/**
+	 * @param nameUsedInReference the nameUsedInReference to set
+	 */
+	public void setNameUsedInSource(TaxonNameBase nameUsedInSource) {
+		this.nameUsedInSource = nameUsedInSource;
+	}
+
+
+//*********************************** CLONE *********************************************************/
+	
+	
+	/**
+	 * Clones this original source and sets the clones sourced object to 'sourceObj'
+	 * @see java.lang.Object#clone()
+	 */
+	public DescriptionElementSource clone(DescriptionElementBase sourcedObj) throws CloneNotSupportedException{
+		DescriptionElementSource result = (DescriptionElementSource)clone();
+		result.setSourcedObj(sourcedObj);
+		return result;
+	}
+	
+		 
+	/* (non-Javadoc)
+	 * @see eu.etaxonomy.cdm.model.common.OriginalSourceBase#clone()
+	 * @see java.lang.Object#clone()
+	 */
+	@Override
+	public Object clone() throws CloneNotSupportedException{
+		DescriptionElementSource result = (DescriptionElementSource)super.clone();
+		
+		//no changes to: sourcedObj
+		return result;
+	}
+
+	
+	
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/Feature.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/Feature.java
index dea10efb22..126154edb5 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/Feature.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/Feature.java
@@ -35,12 +35,13 @@ import org.apache.log4j.Logger;
 import org.hibernate.envers.Audited;
 import org.hibernate.search.annotations.Indexed;
 
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.HybridRelationshipType;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
 
 /**
  * The class for individual properties (also designed as character, type or
@@ -68,7 +69,6 @@ import eu.etaxonomy.cdm.model.occurrence.Specimen;
  * schema.
  * 
  * @author m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:24
  */
 @XmlAccessorType(XmlAccessType.PROPERTY)
@@ -116,7 +116,7 @@ public class Feature extends DefinedTermBase<Feature> {
 	 */
 	@OneToMany(fetch = FetchType.LAZY)
     @JoinTable(name="DefinedTermBase_RecommendedModifierEnumeration")
-	private Set<TermVocabulary<Modifier>> recommendedModifierEnumeration = new HashSet<TermVocabulary<Modifier>>();
+	private Set<TermVocabulary<DefinedTerm>> recommendedModifierEnumeration = new HashSet<TermVocabulary<DefinedTerm>>();
 	
 	
 	@ManyToMany(fetch = FetchType.LAZY)
@@ -138,13 +138,10 @@ public class Feature extends DefinedTermBase<Feature> {
 	
 /* ***************** CONSTRUCTOR AND FACTORY METHODS **********************************/
 	
-
-	/** 
-	 * Class constructor: creates a new empty feature instance.
-	 * 
-	 * @see #Feature(String, String, String)
-	 */
-	public Feature() {
+	//for hibernate use only
+	@Deprecated
+	protected Feature() {
+		super(TermType.Feature);
 	}
 	
 	/** 
@@ -159,7 +156,7 @@ public class Feature extends DefinedTermBase<Feature> {
 	 * @see 				 #Feature()
 	 */
 	protected Feature(String term, String label, String labelAbbrev) {
-		super(term, label, labelAbbrev);
+		super(TermType.Feature, term, label, labelAbbrev);
 	}
 
 	/** 
@@ -347,7 +344,7 @@ public class Feature extends DefinedTermBase<Feature> {
 	@XmlElement(name = "RecommendedModifierEnumeration")
 	@XmlIDREF
 	@XmlSchemaType(name = "IDREF")
-	public Set<TermVocabulary<Modifier>> getRecommendedModifierEnumeration() {
+	public Set<TermVocabulary<DefinedTerm>> getRecommendedModifierEnumeration() {
 		return recommendedModifierEnumeration;
 	}
 
@@ -360,7 +357,7 @@ public class Feature extends DefinedTermBase<Feature> {
 	 * @see    	   								#getRecommendedModifierEnumeration()
 	 */
 	public void addRecommendedModifierEnumeration(
-			TermVocabulary<Modifier> recommendedModifierEnumeration) {
+			TermVocabulary<DefinedTerm> recommendedModifierEnumeration) {
 		this.recommendedModifierEnumeration.add(recommendedModifierEnumeration);
 	}
 	/** 
@@ -372,7 +369,7 @@ public class Feature extends DefinedTermBase<Feature> {
 	 * @see     								#addRecommendedModifierEnumeration(TermVocabulary)
 	 */
 	public void removeRecommendedModifierEnumeration(
-			TermVocabulary<Modifier> recommendedModifierEnumeration) {
+			TermVocabulary<DefinedTerm> recommendedModifierEnumeration) {
 		this.recommendedModifierEnumeration.remove(recommendedModifierEnumeration);
 	}
 
@@ -586,8 +583,8 @@ public class Feature extends DefinedTermBase<Feature> {
 	 * @see     		#NewInstance(String, String, String)
 	 */
 	@Override
-	public Feature readCsvLine(Class<Feature> termClass, List<String> csvLine, Map<UUID,DefinedTermBase> terms) {
-		Feature newInstance = super.readCsvLine(termClass, csvLine, terms); 
+	public Feature readCsvLine(Class<Feature> termClass, List<String> csvLine, Map<UUID,DefinedTermBase> terms, boolean abbrevAsId) {
+		Feature newInstance = super.readCsvLine(termClass, csvLine, terms, abbrevAsId); 
 		String text = (String)csvLine.get(4);
 		if (text != null && text.length() >= 6){
 			if ("1".equals(text.substring(0, 1))){newInstance.setSupportsTextData(true);};
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/FeatureNode.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/FeatureNode.java
index ecb6959e9a..ae09f63322 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/FeatureNode.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/FeatureNode.java
@@ -22,8 +22,9 @@ import javax.persistence.ManyToMany;
 import javax.persistence.ManyToOne;
 import javax.persistence.OneToMany;
 import javax.persistence.OrderBy;
+import javax.persistence.OrderColumn;
 import javax.persistence.Transient;
-import javax.validation.constraints.NotNull;
+import javax.validation.constraints.Size;
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
@@ -36,9 +37,9 @@ import javax.xml.bind.annotation.XmlType;
 import org.apache.log4j.Logger;
 import org.hibernate.annotations.Cascade;
 import org.hibernate.annotations.CascadeType;
-import org.hibernate.annotations.IndexColumn;
 import org.hibernate.envers.Audited;
 
+import eu.etaxonomy.cdm.model.common.ITreeNode;
 import eu.etaxonomy.cdm.model.common.VersionableEntity;
 
 /**
@@ -51,7 +52,6 @@ import eu.etaxonomy.cdm.model.common.VersionableEntity;
  * the node N1.
  * 
  * @author  m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:16
  */
 @SuppressWarnings("serial")
@@ -60,15 +60,16 @@ import eu.etaxonomy.cdm.model.common.VersionableEntity;
 		"featureTree",
 		"feature",
 		"parent",
-		"children",
+		"treeIndex",
 		"sortIndex",
+		"children",
 		"onlyApplicableIf",
 		"inapplicableIf"
 })
 @XmlRootElement(name = "FeatureNode")
 @Entity
 @Audited
-public class FeatureNode extends VersionableEntity implements Cloneable {
+public class FeatureNode extends VersionableEntity implements ITreeNode<FeatureNode>, Cloneable {
 	private static final Logger logger = Logger.getLogger(FeatureNode.class);
 	
     //This is the main key a node belongs to. Although other keys may also reference
@@ -77,7 +78,7 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
     @XmlIDREF
     @XmlSchemaType(name = "IDREF")
     @ManyToOne(fetch = FetchType.LAZY)
-    @Cascade({CascadeType.SAVE_UPDATE, CascadeType.DELETE_ORPHAN})
+    @Cascade({CascadeType.SAVE_UPDATE, CascadeType.DELETE_ORPHAN}) //TODO this usage is incorrect, needed only for OneToMany, check why it is here, can it be removed??
 	 //TODO Val #3379
 //    @NotNull
 	private FeatureTree featureTree;
@@ -92,29 +93,25 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
     @XmlIDREF
     @XmlSchemaType(name = "IDREF")
     @ManyToOne(fetch = FetchType.LAZY, targetEntity=FeatureNode.class)
-//    @IndexColumn(name="sortIndex", base = 0)
     @Cascade(CascadeType.SAVE_UPDATE)
-	@JoinColumn(name="parent_id" /*, insertable=false, updatable=false, nullable=false*/)
+	@JoinColumn(name="parent_id")
 	private FeatureNode parent;
     
+    
+    @XmlElement(name = "treeIndex")
+    @Size(max=255)
+    private String treeIndex;
+    
     @XmlElementWrapper(name = "Children")
     @XmlElement(name = "Child")
-//    @OrderColumn("sortIndex")  //JPA 2.0 same as @IndexColumn
-    // @IndexColumn does not work because not every FeatureNode has a parent. But only NotNull will solve the problem (otherwise 
-    // we will need a join table 
-    // http://stackoverflow.com/questions/2956171/jpa-2-0-ordercolumn-annotation-in-hibernate-3-5
-    // http://docs.jboss.org/hibernate/stable/annotations/reference/en/html_single/#entity-hibspec-collection-extratype-indexbidir
-    //see also https://forum.hibernate.org/viewtopic.php?p=2392563
-    //http://opensource.atlassian.com/projects/hibernate/browse/HHH-4390
-    // reading works, but writing doesn't
-    //
-    @IndexColumn(name="sortIndex", base = 0) 
+    //see https://dev.e-taxonomy.eu/trac/ticket/3722
+    @OrderColumn(name="sortIndex") 
     @OrderBy("sortIndex")
 	@OneToMany(fetch = FetchType.LAZY, mappedBy="parent")
 	@Cascade({CascadeType.SAVE_UPDATE, CascadeType.MERGE})
 	private List<FeatureNode> children = new ArrayList<FeatureNode>();
 
-    //see comment on children @IndexColumn
+    //see https://dev.e-taxonomy.eu/trac/ticket/3722
     private Integer sortIndex;
     
 	@XmlElementWrapper(name = "OnlyApplicableIf")
@@ -197,7 +194,7 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 	/** 
 	 * Returns the feature node <i>this</i> feature node is a child of.
 	 * 
-	 * @see	#getChildren()
+	 * @see	#getChildNodes()
 	 */
 	public FeatureNode getParent() {
 		return parent;
@@ -220,7 +217,7 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 	 * Returns the (ordered) list of feature nodes which are children nodes of
 	 * <i>this</i> feature node.
 	 */
-	public List<FeatureNode> getChildren() {
+	public List<FeatureNode> getChildNodes() {
 		return children;
 	}
 
@@ -230,7 +227,7 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 	 * assign <i>this</i> feature node as the parent of the given child.
 	 * 
 	 * @param	child	the feature node to be added 
-	 * @see				#getChildren() 
+	 * @see				#getChildNodes() 
 	 * @see				#setChildren(List)
 	 * @see				#addChild(FeatureNode, int) 
 	 * @see				#removeChild(FeatureNode)
@@ -249,7 +246,7 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 	 * @param	child	the feature node to be added 
 	 * @param	index	the integer indicating the position at which the child
 	 * 					should be added 
-	 * @see				#getChildren() 
+	 * @see				#getChildNodes() 
 	 * @see				#setChildren(List)
 	 * @see				#addChild(FeatureNode) 
 	 * @see				#removeChild(FeatureNode)
@@ -272,11 +269,11 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 		child.sortIndex = index;
 	}
 	/** 
-	 * Removes the given feature node from the list of {@link #getChildren() children}
+	 * Removes the given feature node from the list of {@link #getChildNodes() children}
 	 * of <i>this</i> feature node.
 	 *
 	 * @param  child	the feature node which should be removed
-	 * @see     		#getChildren()
+	 * @see     		#getChildNodes()
 	 * @see				#addChild(FeatureNode, int) 
 	 * @see				#addChild(FeatureNode) 
 	 * @see				#removeChild(int) 
@@ -289,12 +286,12 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 	}
 	/** 
 	 * Removes the feature node placed at the given (index + 1) position from
-	 * the list of {@link #getChildren() children} of <i>this</i> feature node.
+	 * the list of {@link #getChildNodes() children} of <i>this</i> feature node.
 	 * If the given index is out of bounds no child will be removed. 
 	 *
 	 * @param  index	the integer indicating the position of the feature node to
 	 * 					be removed
-	 * @see     		#getChildren()
+	 * @see     		#getChildNodes()
 	 * @see				#addChild(FeatureNode, int) 
 	 * @see				#addChild(FeatureNode) 
 	 * @see				#removeChild(FeatureNode) 
@@ -315,11 +312,11 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 
 	/** 
 	 * Returns the feature node placed at the given (childIndex + 1) position
-	 * within the list of {@link #getChildren() children} of <i>this</i> feature node.
+	 * within the list of {@link #getChildNodes() children} of <i>this</i> feature node.
 	 * If the given index is out of bounds no child will be returned. 
 	 * 
 	 * @param  childIndex	the integer indicating the position of the feature node
-	 * @see     			#getChildren()
+	 * @see     			#getChildNodes()
 	 * @see					#addChild(FeatureNode, int) 
 	 * @see					#removeChild(int) 
 	 */
@@ -330,7 +327,7 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 	/** 
 	 * Returns the number of children nodes of <i>this</i> feature node.
 	 * 
-	 * @see	#getChildren()
+	 * @see	#getChildNodes()
 	 */
 	@Transient
 	public int getChildCount() {
@@ -339,7 +336,7 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 
 	/** 
 	 * Returns the integer indicating the position of the given feature node
-	 * within the list of {@link #getChildren() children} of <i>this</i> feature node.
+	 * within the list of {@link #getChildNodes() children} of <i>this</i> feature node.
 	 * If the list does not contain this node then -1 will be returned. 
 	 * 
 	 * @param  node	the feature node the position of which is being searched
@@ -359,7 +356,7 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 	 * children (false) or not (true). A node without children is at the
 	 * bottommost level of a tree and is called a leaf.
 	 * 
-	 * @see	#getChildren()
+	 * @see	#getChildNodes()
 	 * @see	#getChildCount()
 	 */
 	@Transient
@@ -513,7 +510,7 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 		
 		features.add(feature);
 		
-		for(FeatureNode childNode : this.getChildren()){
+		for(FeatureNode childNode : this.getChildNodes()){
 			features.addAll(childNode.getDistinctFeaturesRecursive(features));
 		}
 		
@@ -524,9 +521,9 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 		FeatureNode clone = (FeatureNode)this.clone();
 		FeatureNode childClone;
 				
-		for(FeatureNode childNode : this.getChildren()){
+		for(FeatureNode childNode : this.getChildNodes()){
 			childClone = (FeatureNode) childNode.clone();
-			for (FeatureNode childChild:childNode.getChildren()){
+			for (FeatureNode childChild:childNode.getChildNodes()){
 				childClone.addChild(childChild.cloneDescendants());
 			}
 			clone.addChild(childClone);
@@ -564,6 +561,26 @@ public class FeatureNode extends VersionableEntity implements Cloneable {
 		
 	}
 
+// ********************** TREE NODE METHODS ******************************/
+	
+	@Override
+	public String treeIndex() {
+		return this.treeIndex;
+	}
+
+	@Override
+	@Deprecated 
+	public void setTreeIndex(String newTreeIndex) {
+		this.treeIndex = newTreeIndex;
+	}
+
+
+	@Override
+	@Deprecated
+	public int treeId() {
+		return this.featureTree.getId();
+	}
+
 	
 //	//** ********************** TAXON ******************************/
 //	
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/FeatureTree.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/FeatureTree.java
index 62bb6dd909..10f79e6df9 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/FeatureTree.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/FeatureTree.java
@@ -9,6 +9,7 @@
 
 package eu.etaxonomy.cdm.model.description;
 
+import java.net.URI;
 import java.util.ArrayList;
 import java.util.HashSet;
 import java.util.List;
@@ -17,21 +18,28 @@ import java.util.UUID;
 
 import javax.persistence.Entity;
 import javax.persistence.FetchType;
+import javax.persistence.OneToMany;
 import javax.persistence.OneToOne;
 import javax.persistence.Transient;
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
+import javax.xml.bind.annotation.XmlElementWrapper;
 import javax.xml.bind.annotation.XmlRootElement;
 import javax.xml.bind.annotation.XmlType;
 
 import org.apache.log4j.Logger;
 import org.hibernate.annotations.Cascade;
 import org.hibernate.annotations.CascadeType;
+import org.hibernate.annotations.Type;
 import org.hibernate.envers.Audited;
+import org.hibernate.search.annotations.Analyze;
+import org.hibernate.search.annotations.Field;
 import org.hibernate.search.annotations.Indexed;
 
-import eu.etaxonomy.cdm.model.common.TermBase;
+import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
+import eu.etaxonomy.cdm.model.common.Representation;
+import eu.etaxonomy.cdm.strategy.cache.common.IIdentifiableEntityCacheStrategy;
 
 /**
  * The class to arrange {@link Feature features} (characters) in a tree structure.
@@ -49,41 +57,48 @@ import eu.etaxonomy.cdm.model.common.TermBase;
  * depending on their grade of precision.  
  *  
  * @see		MediaKey
+ * 
  * @author  m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:16
  */
 @XmlAccessorType(XmlAccessType.FIELD)
 @XmlType(name = "FeatureTree", propOrder = {
-    "descriptionSeparated",
-    "root"
+    "root",
+    "uri",
+    "representations"
 })
 @XmlRootElement(name = "FeatureTree")
 @Entity
 @Indexed(index = "eu.etaxonomy.cdm.model.description.FeatureTree")
 @Audited
-public class FeatureTree extends TermBase implements Cloneable{
+public class FeatureTree extends IdentifiableEntity<IIdentifiableEntityCacheStrategy> implements Cloneable{
 	private static final long serialVersionUID = -6713834139003172735L;
 	private static final Logger logger = Logger.getLogger(FeatureTree.class);
-	//private Set<FeatureNode> nodes = new HashSet<FeatureNode>();
 	
 	@XmlElement(name = "Root")
 	@OneToOne(fetch = FetchType.LAZY)
 	@Cascade({CascadeType.SAVE_UPDATE, CascadeType.MERGE})
 	private FeatureNode root;
 	
-	@XmlElement(name = "IsDescriptionSeparated")
-	private boolean descriptionSeparated = false;
+
+    // TODO needed? FeatureTree was a TermBase until v3.3 but was removed from
+	//it as TermBase got the termType which does not apply to FeatureTree.
+	//We need to check how far representations and uri is still required
+	//or can be deleted. Current implementations seem all to use the title cache
+	//instead of representation. This may not be correct.
+	@XmlElementWrapper(name = "Representations")
+    @XmlElement(name = "Representation")
+    @OneToMany(fetch=FetchType.EAGER, orphanRemoval=true)
+    @Cascade( { CascadeType.SAVE_UPDATE, CascadeType.MERGE, CascadeType.DELETE})
+    // @IndexedEmbedded no need for embedding since we are using the DefinedTermBaseClassBridge
+    private Set<Representation> representations = new HashSet<Representation>();
+	
+    @XmlElement(name = "URI")
+    @Field(analyze = Analyze.NO)
+    @Type(type="uriUserType")
+    private URI uri;
 		
-	/** 
-	 * Class constructor: creates a new feature tree instance with an empty
-	 * {@link #getRoot() root node}.
-	 */
-	protected FeatureTree() {
-		super();
-		root = FeatureNode.NewInstance();
-		root.setFeatureTree(this);
-	}
+//******************** FACTORY METHODS ******************************************/	
 
 	/** 
 	 * Creates a new feature tree instance with an empty {@link #getRoot() root node}.
@@ -132,27 +147,23 @@ public class FeatureTree extends TermBase implements Cloneable{
 		
 		return result;
 	}
+
 	
-	// Delete the isDescriptionSeparated flag ??
-	/**
-	 * Returns the boolean value of the flag indicating whether the
-	 * {@link DescriptionElementBase description elements} associated with the {@link Feature features}
-	 * belonging to <i>this</i> feature tree should be treated separately (true)
-	 * or not (false).
-	 *  
-	 * @return  the boolean value of the isDescriptionSeparated flag
+// ******************** CONSTRUCTOR *************************************/	
+	
+	/** 
+	 * Class constructor: creates a new feature tree instance with an empty
+	 * {@link #getRoot() root node}.
 	 */
-	public boolean isDescriptionSeparated() {
-		return descriptionSeparated;
+	protected FeatureTree() {
+		super();
+		root = FeatureNode.NewInstance();
+		root.setFeatureTree(this);
 	}
 
-	/**
-	 * @see	#isDescriptionSeparated() 
-	 */
-	public void setDescriptionSeparated(boolean descriptionSeperated) {
-		this.descriptionSeparated = descriptionSeperated;
-	}
+// ****************** GETTER / SETTER **********************************/	
 	
+
 //	@OneToMany
 //	@Cascade({CascadeType.SAVE_UPDATE})
 //	public Set<FeatureNode> getNodes() {
@@ -185,7 +196,7 @@ public class FeatureTree extends TermBase implements Cloneable{
 	@Transient
 	public List<FeatureNode> getRootChildren(){
 		List<FeatureNode> result = new ArrayList<FeatureNode>();
-		result.addAll(root.getChildren());
+		result.addAll(root.getChildNodes());
 		return result;
 	}
 	
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/IIdentificationKey.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/IIdentificationKey.java
index 64c9542ea2..8f591167ed 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/IIdentificationKey.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/IIdentificationKey.java
@@ -14,6 +14,7 @@ import java.util.Set;
 
 import org.apache.poi.poifs.filesystem.OfficeXmlFileException;
 
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 
@@ -48,9 +49,9 @@ public interface IIdentificationKey {
      * The scope of this key, this may be the sex, stage or any other character defined via a subclass
      * of {@link Scope}
      */
-    public Set<Scope> getScopeRestrictions();
-    public void addScopeRestriction(Scope scope);
-    public void removeScopeRestriction(Scope scope);
+    public Set<DefinedTerm> getScopeRestrictions();
+    public void addScopeRestriction(DefinedTerm scope);
+    public void removeScopeRestriction(DefinedTerm scope);
    
     
     /**
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/IModifiable.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/IModifiable.java
index 8e261ec0a6..c5fe081b36 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/IModifiable.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/description/IModifiable.java
@@ -12,12 +12,12 @@ package eu.etaxonomy.cdm.model.description;
 
 import java.util.Set;
 
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.IVersionableEntity;
 
 /**
  * @author n.hoffmann
  * @created Sep 15, 2010
- * @version 1.0
  */
 public interface IModifiable extends IVersionableEntity {
 
@@ -25,7 +25,7 @@ public interface IModifiable extends IVersionableEntity {
 	 * Returns the set of {@link Modifier modifiers} used to qualify the validity
 	 * of <i>this</i> state data. This is only metainformation.
 	 */
-	public Set<Modifier> getModifiers();
+	public Set<DefinedTerm> getModifiers();
 	
 	/**
 	 * Adds a {@link Modifier modifier} to the set of {@link #getModifiers() modifiers}
@@ -34,7 +34,7 @@ public interface IModifiable extends IVersionableEntity {
 	 * @param modifier	the modifier to be added to <i>this</i> state data
 	 * @see    	   		#getModifiers()
 	 */
-	public void addModifier(Modifier modifier);
+	public void addModifier(DefinedTerm modifier);
 	/** 
 	 * Removes one element from the set of {@link #getModifiers() modifiers}
 	 * used to qualify the validity of <i>this</i> state data.
@@ -43,5 +43,5 @@ public interface IModifiable extends IVersionableEntity {
 	 * @see     		#getModifiers()
 	 * @see     		#addModifier(Modifier)
 	 */
-	public void removeModifier(Modifier modifier);
+	public void removeModifier(DefinedTerm modifier);
 }
